import java.awt.Rectangle;

/**
 * Zeichnet ein Rechteck auf die Leinwand.
 * 
 * @author Bernd Gramlich nach einer Vorlage von Michael Klling und David J. Barnes 
 * @version 2010-11-16
 */
public class Rechteck
{
    // Attribute
    private int positionX;
    private int positionY;
    private int breite;
    private int hoehe;
    private String farbe;
    private boolean sichtbar;

    /**
     * Konstruktor der Klasse Rechteck.
     * Erzeugt ein neues Rechteck in Standardgre und Standardfarbe.
     */
    public Rechteck ()
    {
        breite        = 50;
        hoehe         = 140;
        farbe         = "grau";
        sichtbar      = false;
    }
    
	/**
	 * Mache dieses Rechteck sichtbar.
	 */
	public void macheSichtbar ()
	{
		sichtbar = true;
		zeichne ();
	}

	/**
	 * Mache dieses Rechteck unsichtbar.
	 */
	public void macheUnsichtbar ()
	{
		loesche ();
		sichtbar = false;
	}
	
	/**
	 * ndere die Breite des Rechtecks.
	 */
	public void setzeBreite (int neueBreite)
	{
		breite = neueBreite;
		zeichne ();
	}

	/**
	 * ndere die Hhe des Rechtecks.
	 */
	public void setzeHoehe (int neueHoehe)
	{
		hoehe = neueHoehe;
		zeichne ();
	}
		
	/**
	 * ndere die Farbe dieses Rechtecks in 'neueFarbe'. Gltige Angaben
	 * sind "blau", "gelb", "grau", "grn", "lila", "orange", "pink", "rot",
	 * "schwarz", "trkis" und "wei". Jede andere Farbangabe wird als
	 * schwarz interpretiert.
	 */
	public void setzeFarbe (String neueFarbe)
	{
		farbe = neueFarbe;
		zeichne ();
	}
	
	/**
	 * ndere die Position dieses Rechtecks.
	 */
	public void setzePosition (int neuePositionX, int neuePositionY)
	{
		positionX = neuePositionX;
		positionY = neuePositionY;
		zeichne ();
	}		

	/**
	 * Zeichne dieses Rechteck auf die Leinwand.
	 */
	private void zeichne ()
	{
		if (sichtbar)
		{
			Leinwand leinwand = Leinwand.gibLeinwand ();
			leinwand.zeichne (this, farbe, new Rectangle (positionX,
					positionY, breite, hoehe));
		}
	}

	/**
	 * Lsche dieses Rechteck von der Leinwand.
	 */
	private void loesche ()
	{
		if (sichtbar)
		{
			Leinwand leinwand = Leinwand.gibLeinwand ();
			leinwand.entferne (this);
		}
	}   
}